From 54ebe365b752f8969a67279d0d29552ab638e025 Mon Sep 17 00:00:00 2001
From: Witold Filipczyk <witekfl@poczta.onet.pl>
Date: Mon, 6 Mar 2017 17:39:36 +0100
Subject: [PATCH] Compilation fix for OpenSSL-1.1

---
 src/network/ssl/socket.c | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

diff --git src/network/ssl/socket.c src/network/ssl/socket.c
index 886eaf2..bc3621d 100644
--- src/network/ssl/socket.c
+++ src/network/ssl/socket.c
@@ -81,7 +81,9 @@ static void
 ssl_set_no_tls(struct socket *socket)
 {
 #ifdef CONFIG_OPENSSL
-	((ssl_t *) socket->ssl)->options |= SSL_OP_NO_TLSv1;
+#ifdef SSL_OP_NO_TLSv1
+	SSL_set_options((ssl_t *)socket->ssl, SSL_OP_NO_TLSv1);
+#endif
 #elif defined(CONFIG_GNUTLS)
 	{
 		/* GnuTLS does not support SSLv2 because it is "insecure".
@@ -453,7 +455,7 @@ ssl_connect(struct socket *socket)
 		}
 
 		if (client_cert) {
-			SSL_CTX *ctx = ((SSL *) socket->ssl)->ctx;
+			SSL_CTX *ctx = SSL_get_SSL_CTX((SSL *) socket->ssl);
 
 			SSL_CTX_use_certificate_chain_file(ctx, client_cert);
 			SSL_CTX_use_PrivateKey_file(ctx, client_cert,
